"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedVariant(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alternate",
        "calledGenotypes",
        "chromosome",
        "position",
        "reference",
        "reportEvents",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "calledGenotypes": reports_4_0_0.CalledGenotype,
            "reportEvents": reports_4_0_0.ReportEvent,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "org.gel.models.report.avro.CalledGenotype": reports_4_0_0.CalledGenotype,
            "org.gel.models.report.avro.ReportEvent": reports_4_0_0.ReportEvent,
            "org.gel.models.report.avro.ReportedVariant": reports_4_0_0.ReportedVariant,
        }

    __slots__ = [
        "alternate",
        "calledGenotypes",
        "chromosome",
        "position",
        "reference",
        "reportEvents",
        "additionalNumericVariantAnnotations",
        "additionalTextualVariantAnnotations",
        "comments",
        "dbSnpId",
        "evidenceIds",
    ]

    def __init__(
        self,
        alternate,
        calledGenotypes,
        chromosome,
        position,
        reference,
        reportEvents,
        additionalNumericVariantAnnotations=None,
        additionalTextualVariantAnnotations=None,
        comments=None,
        dbSnpId=None,
        evidenceIds=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_0_0.ReportedVariant model.

        :param alternate:
            alternate: Alternate Allele sequence, the same provided in vcf
        :type alternate: str
        :param calledGenotypes:
            array of genotypes for the family
        :type calledGenotypes: list[CalledGenotype]
        :param chromosome:
            chromosome, named as: 1-22,X,Y,MT or other contig names as defined in
            the BAM header
        :type chromosome: str
        :param position:
            position: Position 1-based
        :type position: int
        :param reference:
            reference: Reference Allele sequence, the same provided in vcf
        :type reference: str
        :param reportEvents:
            This is the scores across multiple modes of inheritance, for each
            model of inheritance analyzed,         the variants can
            have only one Report event.
        :type reportEvents: list[ReportEvent]
        :param additionalNumericVariantAnnotations:
            For Example (Allele Frequency, sift, polyphen, mutationTaster, CADD.
            ..)
        :type additionalNumericVariantAnnotations: None | dict[str, float]
        :param additionalTextualVariantAnnotations:
            For example a quote from a paper
        :type additionalTextualVariantAnnotations: None | dict[str, str]
        :param comments:
            Comments
        :type comments: None | list[str]
        :param dbSnpId:
            variant ID in dbSNP
        :type dbSnpId: None | str
        :param evidenceIds:
            For example HGMD ID, dbSNP ID or Pubmed Id
        :type evidenceIds: None | dict[str, str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.0.0"
